window.Gleam.initSearch([{"doc":"glector","title":"glector","content":"# glector\n\n2D vector math for Gleam!\n\n[![Package Version](https://img.shields.io/hexpm/v/glector)](https://hex.pm/packages/glector)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glector/)\n\n```sh\ngleam add glector\n```\n\n```gleam\nimport glector.{Vector2}\n\npub fn main() {\n  glector.dot(Vector2(-6.0, 8.0), Vector2(5.0, 12.0)) // -&gt; 66.0\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glector&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"glector","title":"Vector2","content":"pub type Vector2 {\n  Vector2(x: Float, y: Float)\n}\n\nVector2(x: Float, y: Float)\n\n\nSynonyms:\nglector.Vector2\nglector Vector2","url":"glector.html#Vector2"},{"doc":"glector","title":"zero","content":"pub const zero: Vector2\n The zero vector, or null vector `(0, 0)`.\nSynonyms:\nglector.zero\nglector zero","url":"glector.html#zero"},{"doc":"glector","title":"add","content":"pub fn add(a: Vector2, b: Vector2) -&gt; Vector2\n Adds vector `a` to vector `b`.\n \n add(Vector2(1.0, 2.0), Vector2(3.0, 4.0)) // -&gt; Vector2(4.0, 6.0)\n \nSynonyms:\nglector.add\nglector add","url":"glector.html#add"},{"doc":"glector","title":"cross","content":"pub fn cross(a: Vector2, b: Vector2) -&gt; Float\n Gets the value of the z component of the cross product of vectors `a` and `b`.\n \n Note: the 2D vectors `a` and `b` are treated as 3D vectors where their z component is zero.\n \n cross(Vector2(1.0, 2.0), Vector2(3.0, 4.0)) // -&gt; -2.0\n \nSynonyms:\nglector.cross\nglector cross","url":"glector.html#cross"},{"doc":"glector","title":"dot","content":"pub fn dot(a: Vector2, b: Vector2) -&gt; Float\n Gets the dot product of vectors `a` and `b`.\n \n dot(Vector2(-6.0, 8.0), Vector2(5.0, 12.0)) // -&gt; 66.0\n \nSynonyms:\nglector.dot\nglector dot","url":"glector.html#dot"},{"doc":"glector","title":"invert","content":"pub fn invert(v: Vector2) -&gt; Vector2\n Flips or reverses a vector&#39;s direction.\n \n invert(Vector2(1.0, 2.0)) // -&gt; Vector2(-1.0, -2.0)\n \nSynonyms:\nglector.invert\nglector invert","url":"glector.html#invert"},{"doc":"glector","title":"length","content":"pub fn length(v: Vector2) -&gt; Float\n Gets the length of a vector.\n \n Note: it&#39;s faster to get a vector&#39;s square length than its actual length.\n So for certain use cases like comparing the length of 2 vectors, I recommend using `length_sq` instead.\n \n length(Vector2(8.0, -6.0)) // -&gt; 10.0\n \nSynonyms:\nglector.length\nglector length","url":"glector.html#length"},{"doc":"glector","title":"length_sq","content":"pub fn length_sq(v: Vector2) -&gt; Float\n Gets the square length of a vector.\n \n length_sq(Vector2(8.0, -6.0)) // -&gt; 100.0\n \nSynonyms:\nglector.length_sq\nglector length_sq","url":"glector.html#length_sq"},{"doc":"glector","title":"multiply","content":"pub fn multiply(a: Vector2, b: Vector2) -&gt; Vector2\n Multiplies the x and y components of vectors `a` and `b`.\n \n multiply(Vector2(1.0, 2.0), Vector2(3.0, 4.0)) // -&gt; Vector2(3.0, 8.0)\n \nSynonyms:\nglector.multiply\nglector multiply","url":"glector.html#multiply"},{"doc":"glector","title":"normal","content":"pub fn normal(v: Vector2) -&gt; Vector2\n Gets the normal of a vector representing an edge.\n The winding direction is assumed to be counter-clockwise.\n \n normal(Vector2(-123.0, 0.0)) // -&gt; Vector2(0.0, -1.0)\n \nSynonyms:\nglector.normal\nglector normal","url":"glector.html#normal"},{"doc":"glector","title":"normalize","content":"pub fn normalize(v: Vector2) -&gt; Vector2\n Scales a vector such that its length is `1.0`.\n \n normalize(Vector2(100.0, 0.0)) // -&gt; Vector2(1.0, 0.0)\n \nSynonyms:\nglector.normalize\nglector normalize","url":"glector.html#normalize"},{"doc":"glector","title":"scale","content":"pub fn scale(v: Vector2, scalar: Float) -&gt; Vector2\n Multiplies both components of vector `v` by `scalar`.\n \n scale(Vector2(1.0, 2.0), 2.0) // -&gt; Vector2(2.0, 4.0)\n \nSynonyms:\nglector.scale\nglector scale","url":"glector.html#scale"},{"doc":"glector","title":"subtract","content":"pub fn subtract(a: Vector2, b: Vector2) -&gt; Vector2\n Subtracts vector `b` from vector `a`.\n \n subtract(Vector2(1.0, 2.0), Vector2(3.0, 4.0)) // -&gt; Vector2(-2.0, -2.0)\n \nSynonyms:\nglector.subtract\nglector subtract","url":"glector.html#subtract"},{"doc":"glector","title":"swap","content":"pub fn swap(v: Vector2) -&gt; Vector2\n Swaps the x and y components of a vector around.\n \n swap(Vector2(1.0, -2.0)) // -&gt; Vector2(-2.0, 1.0)\n \nSynonyms:\nglector.swap\nglector swap","url":"glector.html#swap"},{"doc":"glector","title":"glector","content":"","url":"glector.html"}]);